// Code generated by goctl. DO NOT EDIT.
// goctl 1.8.1
// Source: permission.proto

package server

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-permission-server/gen_result/pb/permission"
	"code.30cm.net/digimon/app-cloudep-permission-server/internal/logic/tokenservice"
	"code.30cm.net/digimon/app-cloudep-permission-server/internal/svc"
)

type TokenServiceServer struct {
	svcCtx *svc.ServiceContext
	permission.UnimplementedTokenServiceServer
}

func NewTokenServiceServer(svcCtx *svc.ServiceContext) *TokenServiceServer {
	return &TokenServiceServer{
		svcCtx: svcCtx,
	}
}

// NewToken 建立一個新的 Token，例如：AccessToken
func (s *TokenServiceServer) NewToken(ctx context.Context, in *permission.AuthorizationReq) (*permission.TokenResp, error) {
	l := tokenservicelogic.NewNewTokenLogic(ctx, s.svcCtx)
	return l.NewToken(in)
}

// RefreshToken 更新目前的token 以及裡面包含的一次性 Token
func (s *TokenServiceServer) RefreshToken(ctx context.Context, in *permission.RefreshTokenReq) (*permission.RefreshTokenResp, error) {
	l := tokenservicelogic.NewRefreshTokenLogic(ctx, s.svcCtx)
	return l.RefreshToken(in)
}

// CancelToken 取消 Token，也包含他裡面的 One Time Toke
func (s *TokenServiceServer) CancelToken(ctx context.Context, in *permission.CancelTokenReq) (*permission.OKResp, error) {
	l := tokenservicelogic.NewCancelTokenLogic(ctx, s.svcCtx)
	return l.CancelToken(in)
}

// ValidationToken 驗證這個 Token 有沒有效
func (s *TokenServiceServer) ValidationToken(ctx context.Context, in *permission.ValidationTokenReq) (*permission.ValidationTokenResp, error) {
	l := tokenservicelogic.NewValidationTokenLogic(ctx, s.svcCtx)
	return l.ValidationToken(in)
}

// CancelTokens 取消 Token 從UID 視角，以及 token id 視角出發， UID 登出，底下所有 Device ID 也要登出， Token ID 登出， 所有 UID + Device 都要登出
func (s *TokenServiceServer) CancelTokens(ctx context.Context, in *permission.DoTokenByUIDReq) (*permission.OKResp, error) {
	l := tokenservicelogic.NewCancelTokensLogic(ctx, s.svcCtx)
	return l.CancelTokens(in)
}

// CancelTokenByDeviceID 取消 Token， 從 Device 視角出發，可以選，登出這個Device 下所有 token ，登出這個Device 下指定token
func (s *TokenServiceServer) CancelTokenByDeviceID(ctx context.Context, in *permission.DoTokenByDeviceIDReq) (*permission.OKResp, error) {
	l := tokenservicelogic.NewCancelTokenByDeviceIDLogic(ctx, s.svcCtx)
	return l.CancelTokenByDeviceID(in)
}

// GetUserTokensByDeviceID 取得目前所對應的 DeviceID 所存在的 Tokens
func (s *TokenServiceServer) GetUserTokensByDeviceID(ctx context.Context, in *permission.DoTokenByDeviceIDReq) (*permission.Tokens, error) {
	l := tokenservicelogic.NewGetUserTokensByDeviceIDLogic(ctx, s.svcCtx)
	return l.GetUserTokensByDeviceID(in)
}

// GetUserTokensByUID 取得目前所對應的 UID 所存在的 Tokens
func (s *TokenServiceServer) GetUserTokensByUID(ctx context.Context, in *permission.QueryTokenByUIDReq) (*permission.Tokens, error) {
	l := tokenservicelogic.NewGetUserTokensByUIDLogic(ctx, s.svcCtx)
	return l.GetUserTokensByUID(in)
}

// 取得 Claim
func (s *TokenServiceServer) GetSystemClaimByAccessToken(ctx context.Context, in *permission.GetSystemClaimReq) (*permission.GetSystemClaimResp, error) {
	l := tokenservicelogic.NewGetSystemClaimByAccessTokenLogic(ctx, s.svcCtx)
	return l.GetSystemClaimByAccessToken(in)
}
