package repository

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-permission-server/pkg/domain/entity"
	"go.mongodb.org/mongo-driver/mongo"
)

type RolePermissionRepository interface {
	Get(ctx context.Context, roleID string) ([]*entity.RolePermission, error)
	GetByPermissionID(ctx context.Context, permissionIDs []string) ([]*entity.RolePermission, error)
	Create(ctx context.Context, entity []entity.RolePermission) error
	Delete(ctx context.Context, roleID string, permissions []string) error
	RolePermissionIndex
}

type RolePermissionIndex interface {
	Index20250225UP(ctx context.Context) (*mongo.Cursor, error)
}
