package token

type Additional string

func (a Additional) String() string {
	return string(a)
}

const (
	ID      Additional = "id"
	Role    Additional = "role"
	Device  Additional = "device"
	UID     Additional = "uid"
	Account Additional = "account"
	Scope   Additional = "scope"
	Type    Additional = "token_type"
)

// 定義一個集合存放所有合法的 Additional Keys
var validAdditionalKeys = map[Additional]struct{}{
	ID:      {},
	Role:    {},
	Device:  {},
	UID:     {},
	Account: {},
	Scope:   {},
	Type:    {},
}

// IsValidAdditional 檢查是否是有效的 Additional Key
func IsValidAdditional(key Additional) bool {
	_, exists := validAdditionalKeys[key]

	return exists
}

const (
	Issuer = "permission"
)
