package token

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestType_ToString(t *testing.T) {
	tests := []struct {
		name     string
		input    VerifyType
		expected string
	}{
		{"Empty String", VerifyType(""), ""},
		{"Simple String", VerifyType("read"), "read"},
		{"Complex String", VerifyType("user:write"), "user:write"},
		{"Special Characters", VerifyType("@dmin!"), "@dmin!"},
	}

	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			// 使用指標調用方法
			result := tt.input.ToString()
			assert.Equal(t, tt.expected, result)
		})
	}
}
