package usecase

import "context"

type UserRoleUseCase interface {
	Select(ctx context.Context, filter UserRoleFilter) ([]UserRole, error)
	Get(ctx context.Context, uid string) (UserRole, error)
	Create(ctx context.Context, uid, roleID string) (UserRole, error)
	Update(ctx context.Context, uid, roleID string) error
}

type UserRole struct {
	UID      string `json:"uid"`
	RoleID   string `json:"role_id"`
	CreateAt int64  `json:"create_at"`
	UpdateAt int64  `json:"update_at"`
}

type UserRoleFilter struct {
	RoleID string
}
