package usecase

import (
	"code.30cm.net/digimon/app-cloudep-permission-server/pkg/domain/token"
	"code.30cm.net/digimon/app-cloudep-permission-server/pkg/domain/usecase"
)

// additional 實作 TokenClaims 介面
type additional struct {
	additional map[string]string
}

func (use *additional) GetAll() map[string]string {
	return use.additional
}

func (use *additional) Set(key token.Additional, val string) {
	if use.additional == nil {
		use.additional = make(map[string]string)
	}
	
	use.additional[key.String()] = val
}

func (use *additional) Get(additional token.Additional) string {
	value, ok := use.additional[additional.String()]
	if !ok {
		return ""
	}

	return value
}

// NewAdditional 創建一個新的 tokenClaims 實例
func NewAdditional(data map[string]string) usecase.Additional {
	return &additional{
		additional: data,
	}
}
